package KCSoft.CustomScrollView;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "KCSoft.CustomScrollView", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "KCSoft.CustomScrollView", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static int _lang_list = 0;
public static int _diction_list = 0;
public static int _menu_list = 0;
public static int _area_list = 0;
public static int _village_list = 0;
public static int _prop_list = 0;
public static String _sd_path = "";
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static anywheresoftware.b4a.http.HttpClientWrapper _hc = null;
public static String _url = "";
public static anywheresoftware.b4a.objects.collections.List _listoflangs = null;
public static anywheresoftware.b4a.objects.collections.List _listofjobs = null;
public static anywheresoftware.b4a.objects.collections.Map _listoflngmaps = null;
public static String _imagename = "";
public static String _text1 = "";
public static String _text2 = "";
public static String _text3 = "";
public static String _text4 = "";
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvmain = null;
public httputils2service _httputils2service = null;
public dbutils _dbutils = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 32;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 33;BA.debugLine="CreateDir";
Debug.ShouldStop(1);
_createdir();
 BA.debugLineNum = 34;BA.debugLine="scvMain.Initialize(500)";
Debug.ShouldStop(2);
mostCurrent._scvmain.Initialize(mostCurrent.activityBA,(int)(500));
 BA.debugLineNum = 35;BA.debugLine="Activity.AddView(scvMain,0,0,100%x,100%y)";
Debug.ShouldStop(4);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._scvmain.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 36;BA.debugLine="ListOfJobs.Initialize";
Debug.ShouldStop(8);
_listofjobs.Initialize();
 BA.debugLineNum = 37;BA.debugLine="ListOfLngMaps.Initialize";
Debug.ShouldStop(16);
_listoflngmaps.Initialize();
 BA.debugLineNum = 38;BA.debugLine="hc.Initialize(\"hc\")";
Debug.ShouldStop(32);
_hc.Initialize("hc");
 BA.debugLineNum = 39;BA.debugLine="SQL1.Initialize(SD_PATH, \"homerbg.db\", True)";
Debug.ShouldStop(64);
_sql1.Initialize(_sd_path,"homerbg.db",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 40;BA.debugLine="FetchLangList";
Debug.ShouldStop(128);
_fetchlanglist();
 BA.debugLineNum = 42;BA.debugLine="If ListOfJobs.Size = 0 Then";
Debug.ShouldStop(512);
if (_listofjobs.getSize()==0) { 
 BA.debugLineNum = 43;BA.debugLine="ToastMessageShow(\"Jobs Done!\", True)";
Debug.ShouldStop(1024);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Jobs Done!",anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 47;BA.debugLine="CreateLangTable";
Debug.ShouldStop(16384);
_createlangtable();
 BA.debugLineNum = 52;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 66;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 68;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 62;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 64;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _createdir() throws Exception{
		Debug.PushSubsStack("CreateDir (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 53;BA.debugLine="Sub CreateDir";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 54;BA.debugLine="If File.ExternalWritable Then";
Debug.ShouldStop(2097152);
if (anywheresoftware.b4a.keywords.Common.File.getExternalWritable()) { 
 BA.debugLineNum = 55;BA.debugLine="File.MakeDir(File.DirRootExternal, SD_PATH)";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.File.MakeDir(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),_sd_path);
 BA.debugLineNum = 56;BA.debugLine="SD_PATH = File.DirRootExternal & SD_PATH";
Debug.ShouldStop(8388608);
_sd_path = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal()+_sd_path;
 }else {
 BA.debugLineNum = 58;BA.debugLine="File.MakeDir(File.DirInternal, SD_PATH)";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.File.MakeDir(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),_sd_path);
 BA.debugLineNum = 59;BA.debugLine="SD_PATH = File.DirInternal & SD_PATH";
Debug.ShouldStop(67108864);
_sd_path = anywheresoftware.b4a.keywords.Common.File.getDirInternal()+_sd_path;
 };
 BA.debugLineNum = 61;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _createlangtable() throws Exception{
		Debug.PushSubsStack("CreateLangTable (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 77;BA.debugLine="Sub CreateLangTable";
Debug.ShouldStop(4096);
 BA.debugLineNum = 78;BA.debugLine="Log(\"List of maps = \" & ListOfLangs)";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.Log("List of maps = "+String.valueOf(_listoflangs));
 BA.debugLineNum = 79;BA.debugLine="SQL1.ExecNonQuery(\"DROP TABLE IF EXISTS wp_langs\")";
Debug.ShouldStop(16384);
_sql1.ExecNonQuery("DROP TABLE IF EXISTS wp_langs");
 BA.debugLineNum = 80;BA.debugLine="SQL1.ExecNonQuery(\"CREATE TABLE wp_langs (id INTEGER PRIMARY KEY, abbrev TEXT, lang TEXT, flag TEXT)\")";
Debug.ShouldStop(32768);
_sql1.ExecNonQuery("CREATE TABLE wp_langs (id INTEGER PRIMARY KEY, abbrev TEXT, lang TEXT, flag TEXT)");
 BA.debugLineNum = 81;BA.debugLine="DBUtils.InsertMaps(SQL1, \"wp_langs\", ListOfLangs)";
Debug.ShouldStop(65536);
mostCurrent._dbutils._insertmaps(mostCurrent.activityBA,_sql1,"wp_langs",_listoflangs);
 BA.debugLineNum = 82;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _executeremotequery(String _query,int _taskid) throws Exception{
		Debug.PushSubsStack("ExecuteRemoteQuery (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _req = null;
Debug.locals.put("Query", _query);
Debug.locals.put("TaskId", _taskid);
 BA.debugLineNum = 83;BA.debugLine="Sub ExecuteRemoteQuery(Query As String, TaskId As Int)";
Debug.ShouldStop(262144);
 BA.debugLineNum = 84;BA.debugLine="Dim req As HttpRequest";
Debug.ShouldStop(524288);
_req = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();Debug.locals.put("req", _req);
 BA.debugLineNum = 85;BA.debugLine="req.InitializePost2(\"http://www.homersparadise.com/homerbg/jsonlangs.php\", Query.GetBytes(\"UTF8\"))";
Debug.ShouldStop(1048576);
_req.InitializePost2("http://www.homersparadise.com/homerbg/jsonlangs.php",_query.getBytes("UTF8"));
 BA.debugLineNum = 86;BA.debugLine="hc.Execute(req, TaskId)";
Debug.ShouldStop(2097152);
_hc.Execute(processBA,_req,_taskid);
 BA.debugLineNum = 87;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _fetchlanglist() throws Exception{
		Debug.PushSubsStack("FetchLangList (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 72;BA.debugLine="Sub FetchLangList";
Debug.ShouldStop(128);
 BA.debugLineNum = 73;BA.debugLine="ProgressDialogShow(\"Fetching list of countries\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Fetching list of countries");
 BA.debugLineNum = 75;BA.debugLine="ExecuteRemoteQuery(\"SELECT abbrev,lang,flag FROM wp_langs ORDER BY lang\", LANG_LIST)";
Debug.ShouldStop(1024);
_executeremotequery("SELECT abbrev,lang,flag FROM wp_langs ORDER BY lang",_lang_list);
 BA.debugLineNum = 76;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _fillscrollview() throws Exception{
		Debug.PushSubsStack("FillScrollView (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bitmap1 = null;
anywheresoftware.b4a.objects.PanelWrapper _panel0 = null;
int _paneltop = 0;
int _panelheight = 0;
int _label2top = 0;
int _i = 0;
anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
anywheresoftware.b4a.objects.LabelWrapper _label2 = null;
 BA.debugLineNum = 155;BA.debugLine="Sub FillScrollView";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 156;BA.debugLine="Dim Bitmap1 As Bitmap";
Debug.ShouldStop(134217728);
_bitmap1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("Bitmap1", _bitmap1);
 BA.debugLineNum = 157;BA.debugLine="Dim Panel0 As Panel";
Debug.ShouldStop(268435456);
_panel0 = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("Panel0", _panel0);
 BA.debugLineNum = 158;BA.debugLine="Dim PanelTop, PanelHeight, Label2Top As Int";
Debug.ShouldStop(536870912);
_paneltop = 0;Debug.locals.put("PanelTop", _paneltop);
_panelheight = 0;Debug.locals.put("PanelHeight", _panelheight);
_label2top = 0;Debug.locals.put("Label2Top", _label2top);
 BA.debugLineNum = 159;BA.debugLine="Bitmap1.InitializeSample(File.DirRootExternal, \"/homerbg2/en.png\",80dip,80dip)";
Debug.ShouldStop(1073741824);
_bitmap1.InitializeSample(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"/homerbg2/en.png",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)));
 BA.debugLineNum = 160;BA.debugLine="PanelTop=0";
Debug.ShouldStop(-2147483648);
_paneltop = (int)(0);Debug.locals.put("PanelTop", _paneltop);
 BA.debugLineNum = 161;BA.debugLine="Panel0=scvMain.Panel";
Debug.ShouldStop(1);
_panel0 = mostCurrent._scvmain.getPanel();Debug.locals.put("Panel0", _panel0);
 BA.debugLineNum = 162;BA.debugLine="Panel0.Color=Colors.Gray";
Debug.ShouldStop(2);
_panel0.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 163;BA.debugLine="For i=0 To 9";
Debug.ShouldStop(4);
{
final double step133 = 1;
final double limit133 = (int)(9);
for (_i = (int)(0); (step133 > 0 && _i <= limit133) || (step133 < 0 && _i >= limit133); _i += step133) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 164;BA.debugLine="Bitmap1.InitializeSample(File.DirRootExternal, \"/homerbg2/en.png\",80dip,80dip)";
Debug.ShouldStop(8);
_bitmap1.InitializeSample(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"/homerbg2/en.png",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)));
 BA.debugLineNum = 165;BA.debugLine="Dim Panel1 As Panel";
Debug.ShouldStop(16);
_panel1 = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("Panel1", _panel1);
 BA.debugLineNum = 166;BA.debugLine="Dim ImageView1 As ImageView";
Debug.ShouldStop(32);
_imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();Debug.locals.put("ImageView1", _imageview1);
 BA.debugLineNum = 168;BA.debugLine="Panel1.Initialize(\"\")";
Debug.ShouldStop(128);
_panel1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 169;BA.debugLine="If i Mod 2 = 0 Then";
Debug.ShouldStop(256);
if (_i%2==0) { 
 BA.debugLineNum = 170;BA.debugLine="PanelHeight=99dip";
Debug.ShouldStop(512);
_panelheight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(99));Debug.locals.put("PanelHeight", _panelheight);
 BA.debugLineNum = 171;BA.debugLine="Label2Top=75dip";
Debug.ShouldStop(1024);
_label2top = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(75));Debug.locals.put("Label2Top", _label2top);
 }else {
 BA.debugLineNum = 173;BA.debugLine="PanelHeight=74dip";
Debug.ShouldStop(4096);
_panelheight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(74));Debug.locals.put("PanelHeight", _panelheight);
 };
 BA.debugLineNum = 175;BA.debugLine="Panel0.AddView(Panel1,0,PanelTop,scvMain.Width,PanelHeight)";
Debug.ShouldStop(16384);
_panel0.AddView((android.view.View)(_panel1.getObject()),(int)(0),_paneltop,mostCurrent._scvmain.getWidth(),_panelheight);
 BA.debugLineNum = 176;BA.debugLine="Panel1.Color=Colors.Black";
Debug.ShouldStop(32768);
_panel1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 177;BA.debugLine="Dim Label1, Label2 As Label";
Debug.ShouldStop(65536);
_label1 = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("Label1", _label1);
_label2 = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("Label2", _label2);
 BA.debugLineNum = 179;BA.debugLine="Label1.Initialize(\"\")";
Debug.ShouldStop(262144);
_label1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 180;BA.debugLine="Panel1.AddView(Label1,80dip,5dip,240dip,30dip)";
Debug.ShouldStop(524288);
_panel1.AddView((android.view.View)(_label1.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(240)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 181;BA.debugLine="Label1.Color=Colors.Black";
Debug.ShouldStop(1048576);
_label1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 182;BA.debugLine="Label1.Tag=\"Label1\"";
Debug.ShouldStop(2097152);
_label1.setTag((Object)("Label1"));
 BA.debugLineNum = 183;BA.debugLine="Label1.Text=Text1";
Debug.ShouldStop(4194304);
_label1.setText((Object)(_text1));
 BA.debugLineNum = 185;BA.debugLine="Label2.Initialize(\"\")";
Debug.ShouldStop(16777216);
_label2.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 186;BA.debugLine="Panel1.AddView(Label2,80dip,Label2Top,240dip,30dip)";
Debug.ShouldStop(33554432);
_panel1.AddView((android.view.View)(_label2.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),_label2top,anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(240)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 187;BA.debugLine="Label2.TextSize=14";
Debug.ShouldStop(67108864);
_label2.setTextSize((float)(14));
 BA.debugLineNum = 188;BA.debugLine="Label2.Tag=\"Label2\"";
Debug.ShouldStop(134217728);
_label2.setTag((Object)("Label2"));
 BA.debugLineNum = 189;BA.debugLine="Label2.Text=Text2";
Debug.ShouldStop(268435456);
_label2.setText((Object)(_text2));
 BA.debugLineNum = 190;BA.debugLine="Label2.TextSize=14";
Debug.ShouldStop(536870912);
_label2.setTextSize((float)(14));
 BA.debugLineNum = 192;BA.debugLine="ImageView1.Initialize(\"\")";
Debug.ShouldStop(-2147483648);
_imageview1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 193;BA.debugLine="Panel1.AddView(ImageView1,5dip,5dip,65dip,65dip)";
Debug.ShouldStop(1);
_panel1.AddView((android.view.View)(_imageview1.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(65)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(65)));
 BA.debugLineNum = 194;BA.debugLine="ImageView1.Bitmap=Bitmap1";
Debug.ShouldStop(2);
_imageview1.setBitmap((android.graphics.Bitmap)(_bitmap1.getObject()));
 BA.debugLineNum = 196;BA.debugLine="PanelTop=PanelTop+PanelHeight+1dip";
Debug.ShouldStop(8);
_paneltop = (int)(_paneltop+_panelheight+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1)));Debug.locals.put("PanelTop", _paneltop);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 198;BA.debugLine="Panel0.Height=PanelTop";
Debug.ShouldStop(32);
_panel0.setHeight(_paneltop);
 BA.debugLineNum = 199;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 33615, new int[] {7, 4, 3, 11}, "f7015e0d-5996-41c3-b594-1a8d532716d1");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
httputils2service._process_globals();
dbutils._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, httputils2service.class));
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 28;BA.debugLine="Dim scvMain As ScrollView";
mostCurrent._scvmain = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _hc_responseerror(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,String _reason,int _statuscode,int _taskid) throws Exception{
		Debug.PushSubsStack("hc_ResponseError (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Response", _response);
Debug.locals.put("Reason", _reason);
Debug.locals.put("StatusCode", _statuscode);
Debug.locals.put("TaskId", _taskid);
 BA.debugLineNum = 88;BA.debugLine="Sub hc_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 89;BA.debugLine="Log(\"Error: \" & Reason & \", StatusCode: \" & StatusCode)";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Log("Error: "+_reason+", StatusCode: "+BA.NumberToString(_statuscode));
 BA.debugLineNum = 90;BA.debugLine="If Response <> Null Then";
Debug.ShouldStop(33554432);
if (_response!= null) { 
 BA.debugLineNum = 91;BA.debugLine="Log(Response.GetString(\"UTF8\"))";
Debug.ShouldStop(67108864);
anywheresoftware.b4a.keywords.Common.Log(_response.GetString("UTF8"));
 BA.debugLineNum = 92;BA.debugLine="Response.Release";
Debug.ShouldStop(134217728);
_response.Release();
 };
 BA.debugLineNum = 94;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(536870912);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 95;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _hc_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
		Debug.PushSubsStack("hc_ResponseSuccess (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String _res = "";
anywheresoftware.b4a.objects.collections.JSONParser _parser = null;
anywheresoftware.b4a.objects.collections.List _langs = null;
httpjob[] _jobarray = null;
String[] _langarray = null;
int _i = 0;
anywheresoftware.b4a.objects.collections.Map _m = null;
httpjob _job = null;
Debug.locals.put("Response", _response);
Debug.locals.put("TaskId", _taskid);
 BA.debugLineNum = 96;BA.debugLine="Sub hc_ResponseSuccess (Response As HttpResponse, TaskId As Int)";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 97;BA.debugLine="Log(\"Website results - \" & Response)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log("Website results - "+String.valueOf(_response));
 BA.debugLineNum = 98;BA.debugLine="Dim res As String";
Debug.ShouldStop(2);
_res = "";Debug.locals.put("res", _res);
 BA.debugLineNum = 99;BA.debugLine="res = Response.GetString(\"UTF8\")";
Debug.ShouldStop(4);
_res = _response.GetString("UTF8");Debug.locals.put("res", _res);
 BA.debugLineNum = 100;BA.debugLine="Dim parser As JSONParser";
Debug.ShouldStop(8);
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();Debug.locals.put("parser", _parser);
 BA.debugLineNum = 101;BA.debugLine="parser.Initialize(res)";
Debug.ShouldStop(16);
_parser.Initialize(_res);
 BA.debugLineNum = 102;BA.debugLine="ListOfLangs.Initialize";
Debug.ShouldStop(32);
_listoflangs.Initialize();
 BA.debugLineNum = 103;BA.debugLine="Dim langs As List";
Debug.ShouldStop(64);
_langs = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("langs", _langs);
 BA.debugLineNum = 104;BA.debugLine="SQL1.BeginTransaction";
Debug.ShouldStop(128);
_sql1.BeginTransaction();
 BA.debugLineNum = 105;BA.debugLine="Select TaskId";
Debug.ShouldStop(256);
switch (BA.switchObjectToInt(_taskid,_lang_list)) {
case 0:
 BA.debugLineNum = 108;BA.debugLine="ListOfJobs.Clear";
Debug.ShouldStop(2048);
_listofjobs.Clear();
 BA.debugLineNum = 109;BA.debugLine="langs = parser.NextArray 'returns a list with maps";
Debug.ShouldStop(4096);
_langs = _parser.NextArray();Debug.locals.put("langs", _langs);
 BA.debugLineNum = 110;BA.debugLine="Dim JobArray(langs.Size) As HttpJob";
Debug.ShouldStop(8192);
_jobarray = new httpjob[_langs.getSize()];
{
int d0 = _jobarray.length;
for (int i0 = 0;i0 < d0;i0++) {
_jobarray[i0] = new httpjob();
}
}
;Debug.locals.put("JobArray", _jobarray);
 BA.debugLineNum = 111;BA.debugLine="Dim LangArray(langs.Size) As String";
Debug.ShouldStop(16384);
_langarray = new String[_langs.getSize()];
java.util.Arrays.fill(_langarray,"");Debug.locals.put("LangArray", _langarray);
 BA.debugLineNum = 114;BA.debugLine="For i = 0 To langs.Size - 1";
Debug.ShouldStop(131072);
{
final double step88 = 1;
final double limit88 = (int)(_langs.getSize()-1);
for (_i = (int)(0); (step88 > 0 && _i <= limit88) || (step88 < 0 && _i >= limit88); _i += step88) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 115;BA.debugLine="Dim m As Map";
Debug.ShouldStop(262144);
_m = new anywheresoftware.b4a.objects.collections.Map();Debug.locals.put("m", _m);
 BA.debugLineNum = 116;BA.debugLine="m = langs.Get(i)";
Debug.ShouldStop(524288);
_m.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_langs.Get(_i)));
 BA.debugLineNum = 118;BA.debugLine="m.Put(\"abbrev\",m.Get(i))";
Debug.ShouldStop(2097152);
_m.Put((Object)("abbrev"),_m.Get((Object)(_i)));
 BA.debugLineNum = 119;BA.debugLine="m.Put(\"lang\", m.Get(i))";
Debug.ShouldStop(4194304);
_m.Put((Object)("lang"),_m.Get((Object)(_i)));
 BA.debugLineNum = 120;BA.debugLine="m.Put(\"flag\", m.Get(i))";
Debug.ShouldStop(8388608);
_m.Put((Object)("flag"),_m.Get((Object)(_i)));
 BA.debugLineNum = 121;BA.debugLine="Dim Job As HttpJob";
Debug.ShouldStop(16777216);
_job = new httpjob();Debug.locals.put("Job", _job);
 BA.debugLineNum = 122;BA.debugLine="imagename = m.Get(\"flag\")";
Debug.ShouldStop(33554432);
_imagename = String.valueOf(_m.Get((Object)("flag")));
 BA.debugLineNum = 123;BA.debugLine="Log(\"Imagename = \"& imagename)";
Debug.ShouldStop(67108864);
anywheresoftware.b4a.keywords.Common.Log("Imagename = "+_imagename);
 BA.debugLineNum = 124;BA.debugLine="Job.Initialize(imagename, Me)";
Debug.ShouldStop(134217728);
_job._initialize(processBA,_imagename,main.getObject());
 BA.debugLineNum = 125;BA.debugLine="Job.Download(URL & \"images/prop_apps/thumbs/langs/\" & imagename)";
Debug.ShouldStop(268435456);
_job._download(_url+"images/prop_apps/thumbs/langs/"+_imagename);
 BA.debugLineNum = 126;BA.debugLine="JobArray(i) = Job";
Debug.ShouldStop(536870912);
_jobarray[_i] = _job;Debug.locals.put("JobArray", _jobarray);
 BA.debugLineNum = 127;BA.debugLine="ListOfLangs.Add(m)";
Debug.ShouldStop(1073741824);
_listoflangs.Add((Object)(_m.getObject()));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 130;BA.debugLine="ListOfJobs.Addall(JobArray)";
Debug.ShouldStop(2);
_listofjobs.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(_jobarray));
 BA.debugLineNum = 131;BA.debugLine="Log(\"List of jobs - \" & ListOfJobs)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log("List of jobs - "+String.valueOf(_listofjobs));
 break;
}
;
 BA.debugLineNum = 133;BA.debugLine="SQL1.TransactionSuccessful";
Debug.ShouldStop(16);
_sql1.TransactionSuccessful();
 BA.debugLineNum = 134;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 135;BA.debugLine="SQL1.EndTransaction";
Debug.ShouldStop(64);
_sql1.EndTransaction();
 BA.debugLineNum = 136;BA.debugLine="Response.Release";
Debug.ShouldStop(128);
_response.Release();
 BA.debugLineNum = 137;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _jobdone(httpjob _job) throws Exception{
		Debug.PushSubsStack("JobDone (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;
Debug.locals.put("Job", _job);
 BA.debugLineNum = 138;BA.debugLine="Sub JobDone (Job As HttpJob)";
Debug.ShouldStop(512);
 BA.debugLineNum = 139;BA.debugLine="Log(\"JobName = \" & Job.JobName & \", Success = \" & Job.Success)";
Debug.ShouldStop(1024);
anywheresoftware.b4a.keywords.Common.Log("JobName = "+_job._jobname+", Success = "+String.valueOf(_job._success));
 BA.debugLineNum = 140;BA.debugLine="ListOfJobs.RemoveAt(ListOfJobs.IndexOf(Job))";
Debug.ShouldStop(2048);
_listofjobs.RemoveAt(_listofjobs.IndexOf((Object)(_job)));
 BA.debugLineNum = 141;BA.debugLine="If Job.Success = True Then";
Debug.ShouldStop(4096);
if (_job._success==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 142;BA.debugLine="Dim out As OutputStream";
Debug.ShouldStop(8192);
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();Debug.locals.put("out", _out);
 BA.debugLineNum = 143;BA.debugLine="out = File.OpenOutput(SD_PATH, Job.JobName, False)";
Debug.ShouldStop(16384);
_out = anywheresoftware.b4a.keywords.Common.File.OpenOutput(_sd_path,_job._jobname,anywheresoftware.b4a.keywords.Common.False);Debug.locals.put("out", _out);
 BA.debugLineNum = 144;BA.debugLine="File.Copy2(Job.GetInputStream,out)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.File.Copy2((java.io.InputStream)(_job._getinputstream().getObject()),(java.io.OutputStream)(_out.getObject()));
 BA.debugLineNum = 145;BA.debugLine="out.Close";
Debug.ShouldStop(65536);
_out.Close();
 BA.debugLineNum = 146;BA.debugLine="Log(Job.JobName & \" = Done\")";
Debug.ShouldStop(131072);
anywheresoftware.b4a.keywords.Common.Log(_job._jobname+" = Done");
 }else {
 BA.debugLineNum = 148;BA.debugLine="Log(\"Error: \" & Job.ErrorMessage)";
Debug.ShouldStop(524288);
anywheresoftware.b4a.keywords.Common.Log("Error: "+_job._errormessage);
 BA.debugLineNum = 149;BA.debugLine="ToastMessageShow(SD_PATH & Job.JobName, True)";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_sd_path+_job._jobname,anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 151;BA.debugLine="Job.Release";
Debug.ShouldStop(4194304);
_job._release();
 BA.debugLineNum = 153;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Dim LANG_LIST, DICTION_LIST, MENU_LIST, AREA_LIST, VILLAGE_LIST, PROP_LIST As Int";
_lang_list = 0;
_diction_list = 0;
_menu_list = 0;
_area_list = 0;
_village_list = 0;
_prop_list = 0;
 //BA.debugLineNum = 6;BA.debugLine="LANG_LIST = 1";
_lang_list = (int)(1);
 //BA.debugLineNum = 7;BA.debugLine="DICTION_LIST = 0";
_diction_list = (int)(0);
 //BA.debugLineNum = 8;BA.debugLine="Dim SD_PATH As String";
_sd_path = "";
 //BA.debugLineNum = 9;BA.debugLine="SD_PATH = \"/homerbg2/\"";
_sd_path = "/homerbg2/";
 //BA.debugLineNum = 10;BA.debugLine="Dim SQL1 As SQL";
_sql1 = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 11;BA.debugLine="Dim hc As HttpClient";
_hc = new anywheresoftware.b4a.http.HttpClientWrapper();
 //BA.debugLineNum = 12;BA.debugLine="Dim URL As String";
_url = "";
 //BA.debugLineNum = 13;BA.debugLine="URL = \"http://www.homersparadise.com/\"";
_url = "http://www.homersparadise.com/";
 //BA.debugLineNum = 14;BA.debugLine="Dim ListOfLangs As List";
_listoflangs = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 15;BA.debugLine="Dim ListOfJobs As List";
_listofjobs = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 16;BA.debugLine="Dim ListOfLngMaps As Map";
_listoflngmaps = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 17;BA.debugLine="Dim imagename As String";
_imagename = "";
 //BA.debugLineNum = 18;BA.debugLine="Dim Text1, Text2, Text3, Text4 As String";
_text1 = "";
_text2 = "";
_text3 = "";
_text4 = "";
 //BA.debugLineNum = 19;BA.debugLine="Text1=\"22.25  Migrapolis\"";
_text1 = "22.25  Migrapolis";
 //BA.debugLineNum = 20;BA.debugLine="Text2=\"23.00 Kveldsnytt\"";
_text2 = "23.00 Kveldsnytt";
 //BA.debugLineNum = 21;BA.debugLine="Text3=\"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et\"";
_text3 = "Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et";
 //BA.debugLineNum = 22;BA.debugLine="Text4=\"NAT GEO WILD\"";
_text4 = "NAT GEO WILD";
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"LANG_LIST",_lang_list,"DICTION_LIST",_diction_list,"MENU_LIST",_menu_list,"AREA_LIST",_area_list,"VILLAGE_LIST",_village_list,"PROP_LIST",_prop_list,"SD_PATH",_sd_path,"SQL1",_sql1,"hc",_hc,"URL",_url,"ListOfLangs",_listoflangs,"ListOfJobs",_listofjobs,"ListOfLngMaps",_listoflngmaps,"imagename",_imagename,"Text1",_text1,"Text2",_text2,"Text3",_text3,"Text4",_text4,"scvMain",_scvmain,"HttpUtils2Service",Debug.moduleToString(KCSoft.CustomScrollView.httputils2service.class),"DBUtils",Debug.moduleToString(KCSoft.CustomScrollView.dbutils.class)};
}
}
